﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/messages_cap.ini")

# ******************** Load ********************
def load():
	create_popup()

	es.load("soccer_mod_2010/cap/fights")

# ******************** Create popup ********************
def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/popup_admin_cap.ini")

	popup = popuplib.create("sm_popup_admin_cap")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	line = "->1. %s" % (text("spectator"))
	popup.addline(line)

	line = "->2. %s" % (text("fights"))
	popup.addline(line)

	line = "->3. %s" % (text("random_caps"))
	popup.addline(line)

	line = "->4. %s" % (text("random_teams"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (common("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, spec_all)
	popup.submenu(2, "sm_popup_admin_cap_fights")
	popup.select(3, random_caps)
	popup.select(4, random_teams)
	popup.submenu(5, "sm_popup_admin_cap")
	popup.submenu(6, "sm_popup_admin_cap")
	popup.submenu(7, "sm_popup_admin_cap")
	popup.submenu(8, "sm_popup_admin_cap")
	popup.submenu(9, "sm_popup_admin")

# ******************** Popup choices ********************
def spec_all(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		check = es.ServerVar("cap_fight")
		if check == 0:
			lang_msg("cap_start", tokens, 1)

			myPlayerList = playerlib.getPlayerList("#human")
			for ply in myPlayerList:
				if ply.team > 1:
					cmd = "es_changeteam %s 1" % (ply.userid)
					es.server.queuecmd(cmd)

				cmd = 'usermsg hudhint %s "%s"' % (ply.userid, messages("cap_start", tokens, ply.get("lang")))
				es.server.queuecmd(cmd)

			name = es.getplayername(userid)
			tokens = {}
			tokens["name"] = name
			lang_msg("spec", tokens, 0)
		else:
			es.tell(userid, "#green", messages("no_spec_fight", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_spec_match", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_cap", userid)

def random_caps(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("cap_fight")
	if check == 0:
		check = es.ServerVar("match")
		if check == 0:
			name = es.getplayername(userid)
			tokens = {}
			tokens["name"] = name
			lang_msg("random_caps", tokens, 0)

			force_caps()
		else:
			es.tell(userid, "#green", messages("no_random_caps_match", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_random_caps_fight", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_cap", userid)

def random_teams(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("cap_fight")
	if check == 0:
		check = es.ServerVar("match")
		if check == 0:
			name = es.getplayername(userid)
			tokens = {}
			tokens["name"] = name
			lang_msg("random_teams", tokens, 0)

			force_teams()
		else:
			es.tell(userid, "#green", messages("no_random_teams_match", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_random_teams_fight", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_cap", userid)

# ******************** Functions ********************
def lang_msg(text, tokens, center, team = None):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		if team != None:
			tokens["team"] = messages(team, tokens, player.get("lang"))
		if center == 0:
			es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))
		else:
			es.centertell(player.userid, messages(text, tokens, player.get("lang")))

def force_caps():
	tokens = {}
	myPlayerList = playerlib.getPlayerList("#spec,#human")

	length = len(myPlayerList)
	if length > 0:
		length -= 1
		if length > 0:
			number = random.randint(0, length)
		else:
			number = 0

		cmd = "es_changeteam %s %s" % (myPlayerList[number], 2)
		es.server.queuecmd(cmd)

		name = es.getplayername(myPlayerList[number])
		tokens["name"] = name
		lang_msg("random_cap_selected_t", tokens, 0)
	else:
		lang_msg("random_caps_no_t", tokens, 0)

	myPlayerList = playerlib.getPlayerList("#spec,#human")

	length = len(myPlayerList)
	if length > 0:
		length -= 1
		if length > 0:
			number = random.randint(0, length)
		else:
			number = 0

		cmd = "es_changeteam %s %s" % (myPlayerList[number], 3)
		es.server.queuecmd(cmd)

		name = es.getplayername(myPlayerList[number])
		tokens = {}
		tokens["name"] = name
		lang_msg("random_cap_selected_ct", tokens, 0)
	else:
		lang_msg("random_caps_no_ct", tokens, 0)

def force_teams():
	tokens = {}

	myPlayerList = playerlib.getPlayerList("#spec,#human")

	players = len(myPlayerList)
	if players > 0:
		if players > 12:
			players = 12

		count = 1
		team = 2
		while count <= players:
			myPlayerList = playerlib.getPlayerList("#spec,#human")
			length = len(myPlayerList)

			if length > 1:
				number = random.randint(0, (length - 1))
			else:
				number = 0

			cmd = "es_changeteam %s %s" % (myPlayerList[number], team)
			es.server.queuecmd(cmd)

			if team == 2:
				team_name = "terrorists"
			elif team == 3:
				team_name = "counter-terrorists"

			name = es.getplayername(myPlayerList[number])
			tokens["name"] = name
			lang_msg("random_teams_selected_player", tokens, 0, team_name)

			team += 1
			if team > 3:
				team = 2
			
			count += 1
	else:
		lang_msg("random_teams_no_player", tokens, 0)

def delete_popup(name):
	if popuplib.exists(name):
		popuplib.delete(name)

# ******************** Unload ********************
def unload():
	delete_popup("sm_popup_admin_cap")

	es.unload("soccer_mod_2010/cap/fights")