﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/messages_cap_fights.ini")

# ******************** Load ********************
def load():
	load_variables()
	create_popup()

# ******************** Events ********************
def es_map_start(event_var):
	load_variables()

def player_spawn(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("cap_fight")
		if check == 1:
			player = playerlib.getPlayer(event_var["userid"])
			if player.team > 1:
				check = es.ServerVar("sm_cap_fight_frozen")
				if check == 0:
					type = es.ServerVar("sm_cap_fight_type")
					if type == "hegrenade":
						cmd = "es_give %s weapon_hegrenade" % (event_var["userid"])
						es.server.queuecmd(cmd)
					elif type == "weapon_1":
						weapon = "weapon_" + es.ServerVar("sm_cap_weapon_1")
						cmd = "es_give %s %s" % (event_var["userid"], weapon)
						es.server.queuecmd(cmd)
					elif type == "weapon_2":
						weapon = "weapon_" + es.ServerVar("sm_cap_weapon_2")
						cmd = "es_give %s %s" % (event_var["userid"], weapon)
						es.server.queuecmd(cmd)
					elif type == "weapon_3":
						weapon = "weapon_" + es.ServerVar("sm_cap_weapon_3")
						cmd = "es_give %s %s" % (event_var["userid"], weapon)
						es.server.queuecmd(cmd)
					elif type == "high_speed":
						player.setSpeed(2)
				else:
					player.freeze(1)

def player_death(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("cap_fight")
		if check == 1:
			es.set("sm_cap_winner_userid", event_var["attacker"])
			es.set("sm_cap_loser_userid", event_var["userid"])

def round_start(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("cap_fight")
		if check == 1:
			load_variables()

def hegrenade_detonate(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("cap_fight")
		if check == 1:
			check = es.ServerVar("sm_cap_fight_frozen")
			if check == 0:
				type = es.ServerVar("sm_cap_fight_type")
				if type == "hegrenade":
					player = playerlib.getPlayer(event_var["userid"])
					if player.isdead == 0:
						number = player.getHE()
						if number == 0:
							cmd = "es_give %s weapon_hegrenade" % (event_var["userid"])
							es.server.queuecmd(cmd)

def round_end(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("cap_fight")
		if check == 1:
			userid = es.ServerVar("sm_cap_winner_userid")

			name = "sm_popup_%s" % (userid)
			if popuplib.exists(name):
				popuplib.delete(name)

			myPlayerList = playerlib.getPlayerList("#human,#spec")
			length = len(myPlayerList)
			if length > 0:
				create_player_menu(name, messages("select_player"), "#human,#spec", "none", "pick")
				popuplib.send(name, userid)

				es.set("sm_cap_winner_pick", 1)
				es.set("sm_cap_winner_number", 5)
				es.set("sm_cap_loser_number", 5)

			value = es.ServerVar("sm_cmd_cap_pick")
			tokens = {}
			tokens["command"] = value
			player = playerlib.getPlayer(userid)
			es.tell(userid, "#green", messages("pick_command", tokens, player.get("lang")))

			value = es.ServerVar("sm_cap_loser_userid")
			player = playerlib.getPlayer(value)
			es.tell(value, "#green", messages("pick_command", tokens, player.get("lang")))

			load_variables()

# ******************** Load variables ********************
def load_variables():
	es.set("cap_fight", 0)
	es.set("sm_cap_fight_frozen", 0)
	es.set("sm_cap_fight_type", 0)

# ******************** Create popup ********************
def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/popup_admin_cap_fights.ini")

	popup = popuplib.create("sm_popup_admin_cap_fights")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	line = "->1. %s" % (text("knife"))
	popup.addline(line)

	line = "->2. %s" % (text("hegrenade"))
	popup.addline(line)

	value = es.ServerVar("sm_cap_weapon_1")
	tokens = {}
	tokens['weapon'] = value
	line = "->3. %s" % (text("weapon", tokens))
	popup.addline(line)

	value = es.ServerVar("sm_cap_weapon_2")
	tokens = {}
	tokens['weapon'] = value
	line = "->4. %s" % (text("weapon", tokens))
	popup.addline(line)

	value = es.ServerVar("sm_cap_weapon_3")
	tokens = {}
	tokens['weapon'] = value
	line = "->5. %s" % (text("weapon", tokens))
	popup.addline(line)

	line = "->6. %s" % (text("high_speed"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (common("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, freeze)
	popup.select(2, freeze)
	popup.select(3, freeze)
	popup.select(4, freeze)
	popup.select(5, freeze)
	popup.select(6, freeze)
	popup.submenu(7, "sm_popup_admin_cap_fights")
	popup.submenu(8, "sm_popup_admin_cap_fights")
	popup.submenu(9, "sm_popup_admin_cap")

# ******************** Commands ********************
def cmd_pick():
	userid = int(es.getcmduserid())

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	check = int(es.ServerVar("sm_cap_winner_pick"))
	winnerid = int(es.ServerVar("sm_cap_winner_userid"))
	loserid = int(es.ServerVar("sm_cap_loser_userid"))
	if check == 1:
		if winnerid == userid:
			number = int(es.ServerVar("sm_cap_winner_number"))
			if number > 0:
				myPlayerList = playerlib.getPlayerList("#human,#spec")
				length = len(myPlayerList)
				if length > 0:
					create_player_menu(name, messages("select_player"), "#human,#spec", "none", "pick")
					popuplib.send(name, userid)
				else:
					es.tell(userid, "#green", "No players available.")
			else:
				es.tell(userid, "#green", "You can not pick players anymore.")
		elif loserid == userid:
			es.tell(userid, "#green", "It is not your turn to pick.")
		else:
			es.tell(userid, "#green", "You are not a cap.")
	else:
		if winnerid == userid:
			es.tell(userid, "#green", "It is not your turn to pick.")
		elif loserid == userid:
			number = int(es.ServerVar("sm_cap_loser_number"))
			if number > 0:
				myPlayerList = playerlib.getPlayerList("#human,#spec")
				length = len(myPlayerList)
				if length > 0:
					create_player_menu(name, messages("select_player"), "#human,#spec", "none", "pick")
					popuplib.send(name, userid)
				else:
					es.tell(userid, "#green", "No players available.")
			else:
				es.tell(userid, "#green", "You can not pick players anymore.")
		else:
			es.tell(userid, "#green", "You are not a cap.")

# ******************** Popup choices ********************
def freeze(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("match")
	if check == 0:
		check = es.ServerVar("cap_fight")
		if check == 0:
			myPlayerList = playerlib.getPlayerList("#alive")
			for player in myPlayerList:
				player.freeze(1)

			es.set("cap_fight", 1)
			es.set("sm_cap_fight_type", 0)
			es.set("sm_cap_fight_frozen", 1)
			es.set("sm_cap_fight_weapon", 0)

			name = es.getplayername(userid)
			if choice == 1:
				es.set("sm_cap_fight_type", "knife")

				hudhint = messages("ready_knife")

				tokens = {}
				tokens["name"] = name
				message = messages("knife", tokens)
			elif choice == 2:
				es.set("sm_cap_fight_type", "hegrenade")
				es.set("sm_cap_fight_weapon", "weapon_hegrenade")

				hudhint = messages("ready_hegrenade")

				tokens = {}
				tokens["name"] = name
				message = messages("hegrenade", tokens)
			elif choice == 3:
				es.set("sm_cap_fight_type", "weapon_1")
				value = es.ServerVar("sm_cap_weapon_1")
				weapon = "weapon_%s" % (value)
				es.set("sm_cap_fight_weapon", weapon)

				tokens = {}
				tokens["weapon"] = value
				tokens["name"] = name
				hudhint = messages("ready_weapon", tokens)
				message = messages("weapon", tokens)
			elif choice == 4:
				es.set("sm_cap_fight_type", "weapon_2")
				value = es.ServerVar("sm_cap_weapon_2")
				weapon = "weapon_%s" % (value)
				es.set("sm_cap_fight_weapon", weapon)

				tokens = {}
				tokens["weapon"] = value
				tokens["name"] = name
				hudhint = messages("ready_weapon", tokens)
				message = messages("weapon", tokens)
			elif choice == 5:
				es.set("sm_cap_fight_type", "weapon_3")
				value = es.ServerVar("sm_cap_weapon_3")
				weapon = "weapon_%s" % (value)
				es.set("sm_cap_fight_weapon", weapon)

				tokens = {}
				tokens["weapon"] = value
				tokens["name"] = name
				hudhint = messages("ready_weapon", tokens)
				message = messages("weapon", tokens)
			elif choice == 6:
				es.set("sm_cap_fight_type", "high_speed")

				hudhint = messages("ready_high_speed")

				tokens = {}
				tokens["name"] = name
				message = messages("high_speed", tokens)

			myPlayerList = playerlib.getPlayerList("#human")
			for ply in myPlayerList:
				cmd = 'usermsg hudhint %s "%s"' % (ply.userid, hudhint)
				es.server.queuecmd(cmd)

			es.msg("#green", message)

			es.centermsg(messages("prepare_fight"))
			gamethread.delayed(1, es.centermsg, (messages("prepare_fight")))
			gamethread.delayed(2, es.centermsg, ("| 3 |"))
			gamethread.delayed(3, es.centermsg, ("| 2 |"))
			gamethread.delayed(4, es.centermsg, ("| 1 |"))
			gamethread.delayed(5, es.centermsg, (messages("fight")))

			gamethread.delayed(5, start, (choice))
		else:
			es.tell(userid, "#green", messages("fight_already_started", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages("no_fight_match", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_cap_fights", userid)

# ******************** Functions ********************
def lang_msg(text, tokens):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def start(choice):
	check = es.ServerVar("cap_fight")
	if check == 1:
		es.set("sm_cap_fight_frozen", 0)

		weapon = es.ServerVar("sm_cap_fight_weapon")

		myPlayerList = playerlib.getPlayerList("#alive")
		for player in myPlayerList:
			player.godmode(0)
			player.freeze(0)
			player.health = 100

			if weapon != "0":
				cmd = "es_give %s %s" % (player.userid, weapon)
				es.server.queuecmd(cmd)
			else:
				check = es.ServerVar("sm_cap_fight_type")
				if check == "high_speed":
					player.setSpeed(2)

def create_player_menu(name, title, users, cancelmenu, block):
	if block == "pick":
		myPopup = popuplib.easymenu(name, None, pick)
	myPopup.settitle(title)

	myPlayerList = playerlib.getPlayerList(users)
	for player in myPlayerList:
		myPopup.addoption(player.userid, player.name)

def pick(userid, choice, keymenuname):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	team = es.getplayerteam(userid)
	cmd = "es_changeteam %s %s" % (choice, team)
	es.server.queuecmd(cmd)

	name = es.getplayername(userid)
	target = es.getplayername(choice)

	tokens = {}
	tokens["name"] = name
	tokens["target"] = target
	lang_msg("pick", tokens)

	winner_number = es.ServerVar("sm_cap_winner_number")
	loser_number = es.ServerVar("sm_cap_loser_number")
	if winner_number > 0 and loser_number > 0:
		winner_pick = es.ServerVar("sm_cap_winner_pick")
		if winner_pick == 1:
			userid = es.ServerVar("sm_cap_loser_userid")
			es.set("sm_cap_winner_pick", 0)
			winner_number -= 1
			es.set("sm_cap_winner_number", winner_number)
		else:
			userid = es.ServerVar("sm_cap_winner_userid")
			es.set("sm_cap_winner_pick", 1)
			loser_number -= 1
			es.set("sm_cap_loser_number", loser_number)

		name = "sm_popup_%s" % (userid)
		if popuplib.exists(name):
			popuplib.delete(name)

		myPlayerList = playerlib.getPlayerList("#human,#spec")
		length = len(myPlayerList)
		if length > 0:
			create_player_menu(name, messages("select_player"), "#human,#spec", "none", "pick")
			popuplib.send(name, userid)

def delete_popup(name):
	if popuplib.exists(name):
		popuplib.delete(name)

# ******************** Unload ********************
def unload():
	delete_popup("sm_popup_admin_cap_fights")