﻿import cmdlib
import es

modules = [
	"cap",
	"match",
	"player",
	"referee",
	"shout",
	"sprint",
	"training"
]

# ******************** Load ********************
def load():
	cmdlib.registerServerCommand("soccer_mod_downloads", downloads, "Main setting")

	cmdlib.registerServerCommand("soccer_mod_cmd_admin", client_admin, "Client command setting")
	cmdlib.registerServerCommand("soccer_mod_cmd_info", client_info, "Client command setting")
	cmdlib.registerServerCommand("soccer_mod_cmd_vote", client_vote, "Client command setting")

	cmdlib.registerServerCommand("soccer_mod_vote_length", vote_length, "Vote setting")
	cmdlib.registerServerCommand("soccer_mod_vote_percentage", vote_percentage, "Vote setting")
	cmdlib.registerServerCommand("soccer_mod_vote_sounds", vote_sounds, "Vote setting")
	cmdlib.registerServerCommand("soccer_mod_vote_sound_start", vote_sound_start, "Vote setting")

	cmdlib.registerServerCommand("soccer_mod_module_cap", module_cap, "Enable module")

	cmdlib.registerServerCommand("soccer_mod_module_match", module_match, "Enable module")
	cmdlib.registerServerCommand("soccer_mod_module_match_stats", module_match_stats, "Enable module")

	cmdlib.registerServerCommand("soccer_mod_module_player", module_player, "Enable module")

	cmdlib.registerServerCommand("soccer_mod_module_referee", module_referee, "Enable module")
	cmdlib.registerServerCommand("soccer_mod_module_referee_warn", module_referee_warn, "Enable module")
	cmdlib.registerServerCommand("soccer_mod_module_referee_punish", module_referee_punish, "Enable module")

	cmdlib.registerServerCommand("soccer_mod_module_shout", module_shout, "Enable module")

	cmdlib.registerServerCommand("soccer_mod_module_sprint", module_sprint, "Enable module")

	cmdlib.registerServerCommand("soccer_mod_module_training", module_training, "Enable module")

	es.server.cmd("exec soccer_mod/soccer_mod.cfg")

	for row in modules:
		value = "sm_module_%s_on" % (row)
		check = es.ServerVar(value)
		if check == 1:
			cmd = "soccer_mod_2010/cfg/%s" % (row)
			es.load(cmd)

# ******************** Events ********************
def es_map_start(event_var):
	check = es.ServerVar("soccer_mod_allowed")
	if check == 1:
		check = es.ServerVar("sm_downloads_on")
		if check == 1:
			es.server.cmd("exec soccer_mod/downloads.cfg")

# ******************** Commands ********************
def downloads(args):
	set_boolean_value("sm_downloads_on", args[0])

def client_admin(args):
	es.set("sm_cmd_admin", args[0])

def client_info(args):
	es.set("sm_cmd_info", args[0])

def client_vote(args):
	es.set("sm_cmd_vote", args[0])

def vote_length(args):
	try:
		check = int(args[0])
		es.set("sm_vote_length", check)
	except ValueError:
		es.set("sm_vote_length", 30)

def vote_percentage(args):
	try:
		check = int(args[0])
		es.set("sm_vote_percentage", check)
	except ValueError:
		es.set("sm_vote_percentage", 100)

def vote_sounds(args):
	set_boolean_value("sm_vote_sounds_on", args[0])

def vote_sound_start(args):
	es.set("sm_vote_sound_start", args[0])

def module_cap(args):
	set_boolean_value("sm_module_cap_on", args[0])

def module_match(args):
	set_boolean_value("sm_module_match_on", args[0])

def module_match_stats(args):
	set_boolean_value("sm_module_match_stats_on", args[0])

def module_player(args):
	set_boolean_value("sm_module_player_on", args[0])

def module_referee(args):
	set_boolean_value("sm_module_referee_on", args[0])

def module_referee_warn(args):
	set_boolean_value("sm_module_referee_warn_on", args[0])

def module_referee_punish(args):
	set_boolean_value("sm_module_referee_punish_on", args[0])

def module_shout(args):
	set_boolean_value("sm_module_shout_on", args[0])

def module_sprint(args):
	set_boolean_value("sm_module_sprint_on", args[0])

def module_training(args):
	set_boolean_value("sm_module_training_on", args[0])

# ******************** Functions ********************
def set_boolean_value(name, value):
	try:
		check = int(value)
		if check == 1:
			es.set(name, 1)
		else:
			es.set(name, 0)
	except ValueError:
		es.set(name, 0)

# ******************** Unload ********************
def unload():
	cmdlib.unregisterServerCommand("soccer_mod_downloads")

	cmdlib.unregisterServerCommand("soccer_mod_cmd_admin")
	cmdlib.unregisterServerCommand("soccer_mod_cmd_info")
	cmdlib.unregisterServerCommand("soccer_mod_cmd_vote")

	cmdlib.unregisterServerCommand("soccer_mod_vote_length")
	cmdlib.unregisterServerCommand("soccer_mod_vote_percentage")
	cmdlib.unregisterServerCommand("soccer_mod_vote_sounds")
	cmdlib.unregisterServerCommand("soccer_mod_vote_sound_start")

	cmdlib.unregisterServerCommand("soccer_mod_module_cap")

	cmdlib.unregisterServerCommand("soccer_mod_module_match")
	cmdlib.unregisterServerCommand("soccer_mod_module_match_stats")

	cmdlib.unregisterServerCommand("soccer_mod_module_player")

	cmdlib.unregisterServerCommand("soccer_mod_module_referee")
	cmdlib.unregisterServerCommand("soccer_mod_module_referee_warn")
	cmdlib.unregisterServerCommand("soccer_mod_module_referee_punish")

	cmdlib.unregisterServerCommand("soccer_mod_module_shout")

	cmdlib.unregisterServerCommand("soccer_mod_module_sprint")

	cmdlib.unregisterServerCommand("soccer_mod_module_training")

	for row in modules:
		value = "sm_module_%s_on" % (row)
		check = es.ServerVar(value)
		if check == 1:
			cmd = "soccer_mod_2010/cfg/%s" % (row)
			es.unload(cmd)