﻿import es
import gamethread
import langlib
import math
import playerlib
import popuplib
import random

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/match/messages_match_time.ini")

# ******************** Load ********************
def load():
	create_popups()

# ******************** Create popups ********************
def create_popups():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/match/popup_match_won.ini")
	popup = popuplib.create("sm_popup_match_win")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")
	popup.addline(text("beer"))
	popup.addline(" ")

	line = "->1. %s" % (common("yes"))
	popup.addline(line)

	line = "->2. %s" % (common("no"))
	popup.addline(line)

	popup.addline(" ")

	line = "0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, beer)
	popup.submenu(3, "sm_popup_match_win")
	popup.submenu(4, "sm_popup_match_win")
	popup.submenu(5, "sm_popup_match_win")
	popup.submenu(6, "sm_popup_match_win")
	popup.submenu(7, "sm_popup_match_win")
	popup.submenu(8, "sm_popup_match_win")
	popup.submenu(9, "sm_popup_match_win")

	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/match/popup_match_lost.ini")
	popup = popuplib.create("sm_popup_match_lose")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")
	popup.addline(text("end"))
	popup.addline(" ")

	line = "->1. %s" % (common("yes"))
	popup.addline(line)

	line = "->2. %s" % (common("no"))
	popup.addline(line)

	popup.addline(" ")

	line = "0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, fireworks)
	popup.submenu(3, "sm_popup_match_lose")
	popup.submenu(4, "sm_popup_match_lose")
	popup.submenu(5, "sm_popup_match_lose")
	popup.submenu(6, "sm_popup_match_lose")
	popup.submenu(7, "sm_popup_match_lose")
	popup.submenu(8, "sm_popup_match_lose")
	popup.submenu(9, "sm_popup_match_lose")

# ******************** Popup choices ********************
def beer(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	change_view(userid)
	gamethread.delayed(0.2, change_view, (userid))
	gamethread.delayed(0.4, change_view, (userid))
	gamethread.delayed(0.6, change_view, (userid))
	gamethread.delayed(0.8, change_view, (userid))
	gamethread.delayed(1, change_view, (userid))
	gamethread.delayed(1.2, change_view, (userid))
	gamethread.delayed(1.4, change_view, (userid))
	gamethread.delayed(1.6, change_view, (userid))
	gamethread.delayed(1.8, change_view, (userid))
	gamethread.delayed(2, change_view, (userid))
	gamethread.delayed(2.2, change_view, (userid))
	gamethread.delayed(2.4, change_view, (userid))
	gamethread.delayed(2.6, change_view, (userid))
	gamethread.delayed(2.8, change_view, (userid))
	gamethread.delayed(3, change_view, (userid))
	gamethread.delayed(3.2, change_view, (userid))
	gamethread.delayed(3.4, change_view, (userid))
	gamethread.delayed(3.6, change_view, (userid))
	gamethread.delayed(3.8, change_view, (userid))
	gamethread.delayed(4, change_view, (userid))
	gamethread.delayed(4.2, change_view, (userid))
	gamethread.delayed(4.4, change_view, (userid))
	gamethread.delayed(4.6, change_view, (userid))
	gamethread.delayed(4.8, change_view, (userid))
	gamethread.delayed(5, change_view, (userid, 90))

	es.centertell(userid, messages("beer", tokens, player.get("lang")))

def fireworks(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	es.centertell(userid, messages("fireworks", tokens, player.get("lang")))

	cmd = "usermsg shake %s 2 100" % (userid)
	es.server.queuecmd(cmd)

	sound = es.ServerVar("sm_referee_sound_fireworks")
	es.emitsound("player", userid, sound, "1.0", "0.5")

	push_player(userid, 5)
	gamethread.delayed(0.1, push_player, (userid, 20))
	gamethread.delayed(0.2, push_player, (userid, 45))
	gamethread.delayed(0.3, push_player, (userid, 80))
	gamethread.delayed(0.4, push_player, (userid, 125))
	gamethread.delayed(0.5, push_player, (userid, 180))
	gamethread.delayed(0.6, push_player, (userid, 245))
	gamethread.delayed(0.7, push_player, (userid, 320))
	gamethread.delayed(0.8, push_player, (userid, 405))
	gamethread.delayed(0.9, push_player, (userid, 500))
	gamethread.delayed(1, push_player, (userid, 605))
	gamethread.delayed(1.1, push_player, (userid, 720))
	gamethread.delayed(1.2, push_player, (userid, 845))
	gamethread.delayed(1.3, push_player, (userid, 980))
	gamethread.delayed(1.4, push_player, (userid, 1125))
	gamethread.delayed(1.5, push_player, (userid, 1280))
	gamethread.delayed(1.6, push_player, (userid, 1445))
	gamethread.delayed(1.7, push_player, (userid, 1620))
	gamethread.delayed(1.8, push_player, (userid, 1805))
	gamethread.delayed(1.9, push_player, (userid, 2000))

	gamethread.delayed(2.5, explosion, (userid))
	gamethread.delayed(2.5, kill_player, (userid))

# ******************** Events ********************
def player_spawn(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("match")
		if check == 1:
			period_break_running = es.ServerVar("period_break_running")
			match_paused = int(es.ServerVar("match_paused"))
			if period_break_running == 1 or match_paused == 1:
				player = playerlib.getPlayer(event_var["userid"])
				player.freeze(1)

def round_start(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("match")
		if check == 1:
			period = es.ServerVar("period")
			sm_match_number_periods = int(es.ServerVar("sm_match_number_periods"))
			if period <= sm_match_number_periods:
				check = es.ServerVar("period_running")
				if check == 0:
					check = es.ServerVar("period_break_running")
					if check == 0:
						period_timer(0)

						even = period % 2

						if even == 1:
							team = es.ServerVar("sm_match_name_t")
						else:
							team = es.ServerVar("sm_match_name_ct")

						tokens = {}
						tokens["team"] = team
						lang_msg("kick_off", tokens)
						lang_msg("kick_off", tokens, 1)

			check = es.ServerVar("golden_goal")
			if check == 1:
				golden_goal_timer(0)

				number = random.randint(0, 1)

				if number == 1:
					team = es.ServerVar("sm_match_name_t")
				else:
					team = es.ServerVar("sm_match_name_ct")

				tokens = {}
				tokens["team"] = team
				lang_msg("kick_off", tokens)
				lang_msg("kick_off", tokens, 1)

# ******************** Functions ********************
def lang_msg(text, tokens, center = 0):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		if center == 0:
			es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))
		else:
			es.centertell(player.userid, messages(text, tokens, player.get("lang")))

def change_view(userid, amount = 0):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		if amount == 0:
			amount = random.randint(1, 89)
		es.setplayerprop(userid, "CBasePlayer.m_iDefaultFOV", amount)

def push_player(userid, push):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		prop = "0,0,%s" % (push)
		es.setplayerprop(userid, "CCSPlayer.baseclass.localdata.m_vecBaseVelocity", prop)

def explosion(userid):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		es.emitsound("player", userid, "weapons/hegrenade/explode4.wav", "1.0", "0.5")
		x,y,z = es.getplayerlocation(userid)
		pos1 = "%s,%s,%s" % (x, y, z)
		pos2 = "0,0,0"
		cmd = "es_xeffect sparks %s 9999 3 %s" % (pos1, pos2)
		es.server.queuecmd(cmd)

def kill_player(userid):
	es.sexec(userid, "kill")

def period_timer(time):
	check = es.ServerVar("match")
	if check == 1:
		period = es.ServerVar("period")
		period_length = int(es.ServerVar("sm_match_period_length"))
		time_add = (period - 1) * period_length
		time += time_add

		minutes = int(math.floor(time / 60))
		es.set("sm_match_minutes", minutes)

		seconds = int(time - (minutes * 60))
		es.set("sm_match_seconds", seconds)

		time -= time_add

		score_t = int(es.ServerVar("sm_match_score_t"))
		score_ct = int(es.ServerVar("sm_match_score_ct"))

		name_t = es.ServerVar("sm_match_name_t_abbr")
		name_ct = es.ServerVar("sm_match_name_ct_abbr")

		check = es.ServerVar("sm_match_score_board_on")
		if check == 1:
			check = es.ServerVar("sm_match_swap_home_away_on")
			if check == 0:
				if seconds < 10:
					message = "%s:0%s | %s %s - %s %s" % (minutes, seconds, name_t, score_t, score_ct, name_ct)
				else:
					message = "%s:%s | %s %s - %s %s" % (minutes, seconds, name_t, score_t, score_ct, name_ct)
			else:
				if seconds < 10:
					message = "%s:0%s | %s %s - %s %s" % (minutes, seconds, name_ct, score_ct, score_t, name_t)
				else:
					message = "%s:%s | %s %s - %s %s" % (minutes, seconds, name_ct, score_ct, score_t, name_t)

			myPlayerList = playerlib.getPlayerList("#human")
			for ply in myPlayerList:
				cmd = 'usermsg hudhint %s "%s"' % (ply.userid, message)
				es.server.queuecmd(cmd)

			source_tv = es.ServerVar("tv_name")
			source_tv_id = es.getuserid(source_tv)

			source_tv_on = es.ServerVar("tv_enable")
			if source_tv_on == 1:
				es.menu(1, int(source_tv_id), message)

		check = es.ServerVar("match_paused")
		if check == 0:
			check = es.ServerVar("sm_match_first_hit")
			if check == 0:
				time += 1

		if time <= period_length:
			es.set("period_running", 1)
			es.set("period_break_running", 0)
			gamethread.delayed(1, period_timer, (time))
		else:
			period += 1
			es.set("period", period)

			es.set("period_running", 0)
			es.set("period_break_running", 0)

			periods = int(es.ServerVar("sm_match_number_periods"))
			if period <= periods:
				break_length = int(es.ServerVar("sm_match_period_break_length"))
				freeze_match()
				period_break_timer(break_length)

				check = es.ServerVar("sm_match_sounds_on")
				if check == 1:
					sound = es.ServerVar("sm_match_sound_period_end")
					es.cexec_all("playgamesound", sound)

			else:
				if score_t > score_ct:
					win_t()
				elif score_t < score_ct:
					win_ct()
				elif score_t == score_ct:
					draw()

def freeze_match():
	myPlayerList = playerlib.getPlayerList("#alive")
	for ply in myPlayerList:
		ply.freeze(1)

	cmd = "phys_pushscale 1"
	es.server.queuecmd(cmd)

	cmd = "phys_timescale 0"
	es.server.queuecmd(cmd)

def period_break_timer(time):
	check = es.ServerVar("match")
	if check == 1:
		minutes = int(math.floor(time / 60))
		seconds = int(time - (minutes * 60))

		score_t = es.ServerVar("sm_match_score_t")
		score_ct = es.ServerVar("sm_match_score_ct")

		name_t = es.ServerVar("sm_match_name_t_abbr")
		name_ct = es.ServerVar("sm_match_name_ct_abbr")

		check = es.ServerVar("sm_match_score_board_on")
		if check == 1:
			score_board = es.ServerVar("score_board_period")
			check = es.ServerVar("sm_match_swap_home_away_on")
			if check == 0:
				if seconds < 10:
					message = "%s: %s:0%s | %s %s - %s %s" % (score_board, minutes, seconds, name_t, score_t, score_ct, name_ct)
				else:
					message = "%s: %s:%s | %s %s - %s %s" % (score_board, minutes, seconds, name_t, score_t, score_ct, name_ct)
			else:
				if seconds < 10:
					message = "%s: %s:0%s | %s %s - %s %s" % (score_board, minutes, seconds, name_ct, score_ct, score_t, name_t)
				else:
					message = "%s: %s:%s | %s %s - %s %s" % (score_board, minutes, seconds, name_ct, score_ct, score_t, name_t)

			myPlayerList = playerlib.getPlayerList("#human")
			for ply in myPlayerList:
				cmd = 'usermsg hudhint %s "%s"' % (ply.userid, message)
				es.server.queuecmd(cmd)

			source_tv = es.ServerVar("tv_name")
			source_tv_id = es.getuserid(source_tv)

			source_tv_on = es.ServerVar("tv_enable")
			if source_tv_on == 1:
				es.menu(1, int(source_tv_id), message)

		check = es.ServerVar("match_paused")
		if check == 0:
			time -= 1

		if time > 0:
			es.set("period_running", 0)
			es.set("period_break_running", 1)
			gamethread.delayed(1, period_break_timer, (time))
		else:
			es.set("period_running", 0)
			es.set("period_break_running", 0)
			es.set("sm_match_first_hit", 1)
			cmd = "mp_restartgame 1"
			es.server.queuecmd(cmd)

def golden_goal_timer(time):
	check = es.ServerVar("match")
	if check == 1:
		check = es.ServerVar("golden_goal")
		if check == 1:
			period = es.ServerVar("period")
			period_length = int(es.ServerVar("sm_match_period_length"))
			time_add = (period - 1) * period_length
			time += time_add

			minutes = int(math.floor(time / 60))
			es.set("sm_match_minutes", minutes)

			seconds = int(time - (minutes * 60))
			es.set("sm_match_seconds", seconds)

			time -= time_add

			score_t = es.ServerVar("sm_match_score_t")
			score_ct = es.ServerVar("sm_match_score_ct")

			name_t = es.ServerVar("sm_match_name_t_abbr")
			name_ct = es.ServerVar("sm_match_name_ct_abbr")

			check = es.ServerVar("sm_match_score_board_on")
			if check == 1:
				check = es.ServerVar("sm_match_swap_home_away_on")
				if check == 0:
					if seconds < 10:
						message = "%s: %s:0%s | %s %s - %s %s" % (messages("golden_goal"), minutes, seconds, name_t, score_t, score_ct, name_ct)
					else:
						message = "%s: %s:%s | %s %s - %s %s" % (messages("golden_goal"), minutes, seconds, name_t, score_t, score_ct, name_ct)
				else:
					if seconds < 10:
						message = "%s: %s:0%s | %s %s - %s %s" % (messages("golden_goal"), minutes, seconds, name_ct, score_ct, score_t, name_t)
					else:
						message = "%s: %s:%s | %s %s - %s %s" % (messages("golden_goal"), minutes, seconds, name_ct, score_ct, score_t, name_t)

				myPlayerList = playerlib.getPlayerList("#human")
				for ply in myPlayerList:
					cmd = 'usermsg hudhint %s "%s"' % (ply.userid, message)
					es.server.queuecmd(cmd)

				source_tv = es.ServerVar("tv_name")
				source_tv_id = es.getuserid(source_tv)

				source_tv_on = es.ServerVar("tv_enable")
				if source_tv_on == 1:
					es.menu(1, int(source_tv_id), message)

			check = es.ServerVar("match_paused")
			if check == 0:
				check = es.ServerVar("sm_match_first_hit")
				if check == 0:
					time += 1

			gamethread.delayed(1, golden_goal_timer, (time))

def win_t():
	es.set("match", 0)
	es.set("match_paused", 0)
	es.set("period_running", 0)
	es.set("period_break_running", 0)
	es.set("golden_goal", 0)
	es.set("seconds", 0)
	es.set("minutes", 0)
	es.set("period_break_running", 0)

	score_t = es.ServerVar("sm_match_score_t")
	score_ct = es.ServerVar("sm_match_score_ct")

	name_t = es.ServerVar("sm_match_name_t_abbr")
	name_ct = es.ServerVar("sm_match_name_ct_abbr")

	check = es.ServerVar("sm_match_sounds_on")
	if check == 1:
		sound = es.ServerVar("sm_match_sound_match_end")
		es.cexec_all("playgamesound", sound)

	myPlayerList = playerlib.getPlayerList("#t")
	for player in myPlayerList:
		popuplib.send("sm_popup_match_win", player.userid)

	myPlayerList = playerlib.getPlayerList("#ct")
	for player in myPlayerList:
		popuplib.send("sm_popup_match_lose", player.userid)

	check = es.ServerVar("sm_match_swap_home_away_on")
	if check == 0:
		message = "%s: %s %s - %s %s." % (messages("final_score"), name_t, score_t, score_ct, name_ct)
	else:
		message = "%s: %s %s - %s %s." % (messages("final_score"), name_ct, score_ct, score_t, name_t)
	es.msg("#green", message)

def win_ct():
	es.set("match", 0)
	es.set("match_paused", 0)
	es.set("period_running", 0)
	es.set("period_break_running", 0)
	es.set("golden_goal", 0)
	es.set("seconds", 0)
	es.set("minutes", 0)
	es.set("period_break_running", 0)

	score_t = es.ServerVar("sm_match_score_t")
	score_ct = es.ServerVar("sm_match_score_ct")

	name_t = es.ServerVar("sm_match_name_t_abbr")
	name_ct = es.ServerVar("sm_match_name_ct_abbr")

	check = es.ServerVar("sm_match_sounds_on")
	if check == 1:
		sound = es.ServerVar("sm_match_sound_match_end")
		es.cexec_all("playgamesound", sound)

	myPlayerList = playerlib.getPlayerList("#t")
	for player in myPlayerList:
		popuplib.send("sm_popup_match_lose", player.userid)

	myPlayerList = playerlib.getPlayerList("#ct")
	for player in myPlayerList:
		popuplib.send("sm_popup_match_win", player.userid)

	check = es.ServerVar("sm_match_swap_home_away_on")
	if check == 0:
		message = "%s: %s %s - %s %s." % (messages("final_score"), name_t, score_t, score_ct, name_ct)
	else:
		message = "%s: %s %s - %s %s." % (messages("final_score"), name_ct, score_ct, score_t, name_t)
	es.msg("#green", message)

def draw():
	check = es.ServerVar("sm_match_golden_goal_on")
	if check == 1:
		es.set("golden_goal", 1)

		freeze_match()

		check = es.ServerVar("sm_match_sounds_on")
		if check == 1:
			sound = es.ServerVar("sm_match_sound_period_end")
			es.cexec_all("playgamesound", sound)

		tokens = {}
		lang_msg("draw", tokens)

		es.set("sm_match_first_hit", 1)

		value = es.ServerVar("sm_match_restart_length")
		cmd = "mp_restartgame %s" % (value)
		es.server.queuecmd(cmd)
	else:
		es.set("match", 0)
		es.set("match_paused", 0)
		es.set("period_running", 0)
		es.set("period_break_running", 0)
		es.set("golden_goal", 0)
		es.set("seconds", 0)
		es.set("minutes", 0)
		es.set("period_break_running", 0)

		score_t = es.ServerVar("sm_match_score_t")
		score_ct = es.ServerVar("sm_match_score_ct")

		name_t = es.ServerVar("sm_match_name_t_abbr")
		name_ct = es.ServerVar("sm_match_name_ct_abbr")

		check = es.ServerVar("sm_match_sounds_on")
		if check == 1:
			sound = es.ServerVar("sm_match_sound_match_end")
			es.cexec_all("playgamesound", sound)

		check = es.ServerVar("sm_match_swap_home_away_on")
		if check == 0:
			message = "%s: %s %s - %s %s." % (messages("final_score"), name_t, score_t, score_ct, name_ct)
		else:
			message = "%s: %s %s - %s %s." % (messages("final_score"), name_ct, score_ct, score_t, name_t)
		es.msg("#green", message)

def delete_popups():
	if popuplib.exists("sm_popup_match_win"):
		popuplib.delete("sm_popup_match_win")

	if popuplib.exists("sm_popup_match_lose"):
		popuplib.delete("sm_popup_match_lose")

# ******************** Unload ********************
def unload():
	delete_popups()