﻿import es
import langlib
import playerlib
import popuplib

popup = popuplib.create("sm_popup_admin_settings_player")
common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
texts = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_player.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/messages_settings_player.ini")

# ******************** Load ********************
def load():
	load_settings()
	create_popup()
	es.addons.registerSayFilter(sayFilter)

# ******************** Load variables ********************
def load_settings():
	value = int(es.keygetvalue("soccer_mod_settings", "player", "god_mode"))
	es.set("sm_player_god_mode_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "player", "hurt_sounds"))
	es.set("sm_player_hurt_sounds_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "player", "skins"))
	es.set("sm_player_skins_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "player", "respawn_length"))
	es.set("sm_player_respawn_length", value)

# ******************** Create popup ********************
def create_popup():
	line = "SOCCER MOD %s" % (texts("title"))
	popup.addline(line)

	popup.addline(" ")

	value = es.ServerVar("sm_player_god_mode_on")
	if value == 1:
		value = texts("on")
	else:
		value = texts("off")

	line = "->1. %s: %s" % (texts("god mode"), value)
	popup.addline(line)

	value = es.ServerVar("sm_player_hurt_sounds_on")
	if value == 1:
		value = texts("on")
	else:
		value = texts("off")

	line = "->2. %s: %s" % (texts("hurt sounds"), value)
	popup.addline(line)

	value = es.ServerVar("sm_player_skins_on")
	if value == 1:
		value = texts("on")
	else:
		value = texts("off")

	line = "->3. %s: %s" % (texts("skins"), value)
	popup.addline(line)

	value = es.ServerVar("sm_player_respawn_length")
	line = "->4. %s: %s" % (texts("respawn length"), value)
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (common("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, god_mode)
	popup.select(2, hurt_sounds)
	popup.select(3, skins)
	popup.select(4, respawn_length)
	popup.submenu(5, "sm_popup_admin_settings_player")
	popup.submenu(6, "sm_popup_admin_settings_player")
	popup.submenu(7, "sm_popup_admin_settings_player")
	popup.submenu(8, "sm_popup_admin_settings_player")
	popup.submenu(9, "sm_popup_admin_settings")

# ******************** Popup choices ********************
def god_mode(userid, choice, popupid):
	name = es.getplayername(userid)
	tokens = {}
	tokens["name"] = name

	value = es.ServerVar("sm_player_god_mode_on")
	if value == 1:
		es.set("sm_player_god_mode_on", 0)
		es.keysetvalue("soccer_mod_settings", "player", "god_mode", 0)

		line = "->1. %s: %s" % (texts("god mode"), texts("off"))
		popup.modline(3, line)

		lang_msg_on_off("set_god_mode", tokens, "off")
	else:
		es.set("sm_player_god_mode_on", 1)
		es.keysetvalue("soccer_mod_settings", "player", "god_mode", 1)

		line = "->1. %s: %s" % (texts("god mode"), texts("on"))
		popup.modline(3, line)

		lang_msg_on_off("set_god_mode", tokens, "on")

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_player", userid)

def hurt_sounds(userid, choice, popupid):
	name = es.getplayername(userid)
	tokens = {}
	tokens["name"] = name

	value = es.ServerVar("sm_player_hurt_sounds_on")
	if value == 1:
		es.set("sm_player_hurt_sounds_on", 0)
		es.keysetvalue("soccer_mod_settings", "player", "hurt_sounds", 0)

		line = "->2. %s: %s" % (texts("hurt sounds"), texts("off"))
		popup.modline(4, line)

		lang_msg_on_off("set_hurt_sounds", tokens, "off")
	else:
		es.set("sm_player_hurt_sounds_on", 1)
		es.keysetvalue("soccer_mod_settings", "player", "hurt_sounds", 1)

		line = "->2. %s: %s" % (texts("hurt sounds"), texts("on"))
		popup.modline(4, line)

		lang_msg_on_off("set_hurt_sounds", tokens, "on")

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_player", userid)

def skins(userid, choice, popupid):
	name = es.getplayername(userid)
	tokens = {}
	tokens["name"] = name

	value = es.ServerVar("sm_player_skins_on")
	if value == 1:
		es.set("sm_player_skins_on", 0)
		es.keysetvalue("soccer_mod_settings", "player", "skins", 0)

		line = "->3. %s: %s" % (texts("skins"), texts("off"))
		popup.modline(5, line)

		lang_msg_on_off("set_skins", tokens, "off")
	else:
		es.set("sm_player_skins_on", 1)
		es.keysetvalue("soccer_mod_settings", "player", "skins", 1)

		line = "->3. %s: %s" % (texts("skins"), texts("on"))
		popup.modline(5, line)

		lang_msg_on_off("set_skins", tokens, "on")

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_player", userid)

def respawn_length(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_player_respawn_length")

	tokens = {}
	player = playerlib.getPlayer(userid)
	es.tell(userid, "#green", messages("set_respawn_length_message", tokens, player.get("lang")))

# ******************** Events ********************
def sayFilter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 1:
		tokens = {}
		player = playerlib.getPlayer(userid)

		text = text.strip('"')
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "settings_player_respawn_length":
			if text != "!cancel":
				error = messages("set_respawn_length_message", tokens, player.get("lang"))
				try:
					temp_value = float(text)
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 60:
							es.set("sm_player_respawn_length", value)

							line = "->4. %s: %s" % (texts("respawn length"), value)
							popup.modline(6, line)

							es.keysetvalue("soccer_mod_settings", "player", "respawn_length", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(userid)
							tokens = {}
							tokens["name"] = name
							tokens["value"] = value
							lang_msg("set_respawn_length", tokens)

							clear_key(userid, steamid)
						else:
							es.tell(userid, "#green", error)
					else:
						es.tell(userid, "#green", error)
				except ValueError:
					es.tell(userid, "#green", error)
			else:
				clear_key(userid, steamid)
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def lang_msg_on_off(text, tokens, on_off):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		tokens["value"] = messages(on_off, tokens, player.get("lang"))
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def lang_msg(text, tokens):
	myPlayerList = playerlib.getPlayerList("#human")
	for player in myPlayerList:
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def clear_key(userid, steamid):
	es.keydelete("sm_keygroup_set", steamid)
	popuplib.send("sm_popup_admin_settings_player", userid)

def delete_popup():
	if popuplib.exists("sm_popup_admin_settings_player"):
		popuplib.delete("sm_popup_admin_settings_player")

# ******************** Unload ********************
def unload():
	delete_popup()
	es.addons.unregisterSayFilter(sayFilter)