﻿import es
import gamethread
import langlib
import playerlib
import popuplib

common = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/common.ini")
messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/shout/messages.ini")

used = []

# ******************** Load ********************
def load():
	create_popup()

# ******************** Create popup ********************
def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/shout/popup_shout.ini")

	popup = popuplib.create("sm_popup_shout")

	popup.addline(text("title"))

	line = "1. %s" % (text("foul"))
	popup.addline(line)

	line = "2. %s" % (text("goal"))
	popup.addline(line)

	line = "3. %s" % (text("ole"))
	popup.addline(line)

	line = "4. %s" % (text("pass"))
	popup.addline(line)

	line = "5. %s" % (text("save"))
	popup.addline(line)

	line = "6. %s" % (text("shot"))
	popup.addline(line)

	line = "0. %s" % (common("close"))
	popup.addline(line)

	popup.select(1, shout)
	popup.select(2, shout)
	popup.select(3, shout)
	popup.select(4, shout)
	popup.select(5, shout)
	popup.select(6, shout)
	popup.submenu(7, "sm_popup_shout")
	popup.submenu(8, "sm_popup_shout")
	popup.submenu(9, "sm_popup_shout")

# ******************** Commands ********************
def cmd_shout():
	tokens = {}
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	check = es.ServerVar("soccer_mod_allowed")
	if check == 1:
		player = playerlib.getPlayer(userid)
		if player.isdead == 0:
			popuplib.send("sm_popup_shout", userid)
		else:
			es.tell(userid, "#green", messages("dead", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", common("not_allowed", tokens, player.get("lang")))

# ******************** Popup choices ********************
def shout(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		if player.steamid not in used:
			used.append(player.steamid)

			if choice == 1:
				sound = es.ServerVar("sm_shout_sound_foul")
				es.emitsound("player", userid, sound, "1.0", "1.0")

			elif choice == 2:
				sound = es.ServerVar("sm_shout_sound_goal")
				es.emitsound("player", userid, sound, "1.0", "1.0")

			elif choice == 3:
				sound = es.ServerVar("sm_shout_sound_ole")
				es.emitsound("player", userid, sound, "1.0", "1.0")

			elif choice == 4:
				sound = es.ServerVar("sm_shout_sound_pass")
				es.emitsound("player", userid, sound, "1.0", "1.0")

			elif choice == 5:
				sound = es.ServerVar("sm_shout_sound_save")
				es.emitsound("player", userid, sound, "1.0", "1.0")

			elif choice == 6:
				sound = es.ServerVar("sm_shout_sound_shot")
				es.emitsound("player", userid, sound, "1.0", "1.0")

			delay = es.ServerVar("sm_shout_delay")
			gamethread.delayed(delay, clear_key, (player.steamid))
	else:
		es.tell(userid, "#green", messages("dead", tokens, player.get("lang")))

# ******************** Functions ********************
def clear_key(steamid):
	used.remove(steamid)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_shout")